;Scan2PDF
;by Harkon
;written under PureBasic 5.24
;
;requires:
; EZTW32.dll 
; EZTwain.pbi and needs EZTW32.LIB
;  both are available for download at http://www.dosadi.com/
;  as EZTwain Classic (this is a free download)
; PurePDF by ABBKlaus (appropriate version at http://www.purebasicpower.de/?PurePDF)
; sanner.ico for the .exe
;
; PurePDF 2_25_HK.pbi
; Changed source for PurePDF 2.25 to an include file instead of a library
; made some internal modifcations and included the PurePDF_res.pb code in the include file to make it all one nice package
; deleted the DLL procs to compact the code somewhat
; changed some compiler directives as this will never get compiled for MAC_OS
; left other compiler directives as this may someday be ported to Linux (once I figure out SANE :))

IncludeFile "EZTwain.pbi"
IncludeFile "/PurePDF/PurePDF 2_25_HK.pbi"

EnableExplicit

;- Window Constants
;
Enumeration
  #Window_Scan2PDF
EndEnumeration

;- Gadget Constants
Enumeration
  #Combo_ImageType
  #Combo_ImageQuality
  #Text_ImageType
  #Text_ImageQuality
  #Text_Header
  #Text_FileLocation
  #Text_Location
  #Button_Browse
  #Button_ScanNext
  #Button_Finish
  #Button_Cancel
  #Button_Select_Source
  #Text_VersionInfo
EndEnumeration

;- Fonts
Global lFontID1.l
lFontID1 = LoadFont(1, "Arial", 48, #PB_Font_Bold | #PB_Font_Italic)

;Variable defs
Define sPdfFileName.s
Define lQuality.l
Define lEvent.l
Define lWindowID.l
Define lGadgetID.l
Define lEventType.l
Define sAppPath.s=GetPathPart(ProgramFilename())
Define sCfgFileName.s=sAppPath + "Scan2PDF.cfg"
Define sPgmVersion.s="version 0.1." + Str(#PB_Editor_CompileCount) + "." + Str(#PB_Editor_BuildCount)

Procedure Open_Window_Scan2PDF()
  If OpenWindow(#Window_Scan2PDF, 268, 51, 378, 431, "Scan2PDF",  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar )
      ComboBoxGadget(#Combo_ImageType, 190, 100, 110, 20)
      ComboBoxGadget(#Combo_ImageQuality, 190, 130, 110, 20)
      TextGadget(#Text_ImageType, 80, 100, 90, 20, "Image Type:")
      TextGadget(#Text_ImageQuality, 80, 130, 90, 20, "Image Quality:")
      TextGadget(#Text_Header, 20, 10, 340, 80, "Scan2PDF")
      SetGadgetFont(#Text_Header, lFontID1)
      TextGadget(#Text_FileLocation, 10, 230, 340, 40, "", #PB_Text_Border)
      TextGadget(#Text_Location, 10, 210, 160, 20, "PDF File Destination Location:")
      ButtonGadget(#Button_Browse, 350, 250, 20, 20, "...")
      ButtonGadget(#Button_ScanNext, 90, 300, 90, 30, "Scan Next Page")
      ButtonGadget(#Button_Finish, 200, 300, 90, 30, "Finish")
      ButtonGadget(#Button_Cancel, 120, 350, 150, 30, "Cancel / Close Program")
      ButtonGadget(#Button_Select_Source, 190, 160, 110, 20, "Select Source")
      TextGadget(#Text_VersionInfo, 10, 400, 360, 20, "")
  EndIf
EndProcedure

Procedure.l hkTWAIN_AquireToPDF(wPixTypes.l, dResolution.d, reset.w)
  Static PDFStarted.l
  Static PageNumber.l
  Define hDib.l
  Define sTempFileName.s

  If reset
    PDFStarted=0
    PageNumber=0
    ProcedureReturn 1
  EndIf

  If TWAIN_State()<>#TWAIN_SOURCE_OPEN
      TWAIN_OpenDefaultSource()
  EndIf
    
  If Not TWAIN_GetHideUI()
    TWAIN_SetHideUI(1)
  EndIf

  TWAIN_SetCurrentResolution(dResolution)
  
  ;color should be 4 not 3
  ; this is a hck fix
  If wPixTypes=3
    wPixtypes=4
  EndIf
  
  hDib=TWAIN_AcquireNative(0, wPixTypes)
  
  If hDib
    PageNumber+1
    sTempFileName=GetTemporaryDirectory() + "tempscan" + RSet(Str(PageNumber),3,"0") + ".png"
    
    ;hkTWAIN_WriteNativeToPNG(hdib, sTempFileName)
    hkTWAIN_WriteNativeToJPG(hdib, sTempFileName,7)
    TWAIN_FreeNative(hDib)
  
    
    If Not PDFStarted
      pdf_Create("P", "in", #PDF_PAGE_FORMAT_LETTER)
      pdf_SetTitle("Scan")
      PDFStarted=1
    EndIf
    
    pdf_AddPage("P", #PDF_PAGE_FORMAT_LETTER)
    pdf_Image(sTempFileName, 0, 0, 8.5, 0)
    DeleteFile(sTempFileName)
    
    ;- replace this code with in window code
    SetGadgetText(#Button_ScanNext, "Scan Page #" + Str(PageNumber+1))

    
    ProcedureReturn 1
  EndIf
  ProcedureReturn 0  
EndProcedure

;before we actually do anything let's make sure the app isn't already running
If CreateMutex_(0,1,"Scan2PDF")=0 Or GetLastError_()<>0
  End
EndIf

Open_Window_Scan2PDF()

;- Startupcode
If Not TWAIN_IsAvailable()
  MessageRequester("Scan2PDF", "TWAIN scanner interface is not available!")
  End
EndIf

; populate combo boxes
If Not OpenPreferences(sCfgFileName)
  MessageRequester("Scan2PDF", "Could not find preferences file, using default values")
EndIf

AddGadgetItem(#Combo_ImageType, -1, "Black & White")
AddGadgetItem(#Combo_ImageType, -1, "GrayScale")
AddGadgetItem(#Combo_ImageType, -1, "Color (Photo)")

AddGadgetItem(#Combo_ImageQuality,-1, "  75 dpi")
AddGadgetItem(#Combo_ImageQuality,-1, " 100 dpi")
AddGadgetItem(#Combo_ImageQuality,-1, " 150 dpi")
AddGadgetItem(#Combo_ImageQuality,-1, " 300 dpi")
AddGadgetItem(#Combo_ImageQuality,-1, " 600 dpi")
AddGadgetItem(#Combo_ImageQuality,-1, "1200 dpi")

; initialize gadgets
SetGadgetState(#Combo_ImageType, ReadPreferenceInteger("Color Index", 2))
SetGadgetState(#Combo_ImageQuality, ReadPreferenceInteger("Quality Index", 0))
SetGadgetText(#Text_FileLocation, ReadPreferenceString("Destination File",""))
; disable finish button until we actually have a page to save
DisableGadget(#Button_Finish, 1)
SetGadgetText(#Text_VersionInfo, sPgmVersion)

Repeat ; Start of the event loop
  
  lEvent = WaitWindowEvent() ; This line waits until an event is received from Windows
  lWindowID = EventWindow() ; The Window where the event is generated, can be used in the gadget procedures
  lGadgetID = EventGadget() ; Is it a gadget event?
  lEventType = EventType() ; The event type
  
  If lEvent = #PB_Event_Gadget
    If lGadgetID = #Combo_ImageType  
    ElseIf lGadgetID = #Combo_ImageQuality 
    ElseIf lGadgetID = #Button_Browse
      ;user can select default file destination here
      sPdfFileName=GetGadgetText(#Text_FileLocation)
      If sPdfFileName=""
        sPdfFileName=SaveFileRequester("Save PDF file",GetHomeDirectory()+"My Documents\","PDF (*.pdf)|*.pdf",0)
        Else
        sPdfFileName=SaveFileRequester("Save PDF file",sPdfFileName,"PDF (*.pdf)|*.pdf",0)
      EndIf
      
      If LCase(GetExtensionPart(sPdfFileName))<> "pdf"
        sPdfFileName + ".pdf"
      EndIf
      SetGadgetText(#Text_FileLocation, sPdfFileName)
    
    ElseIf lGadgetID = #Button_ScanNext
      ;get dpi for page here
      ;color depth is in order of index+1
      Select  GetGadgetState(#Combo_ImageQuality)
        Case 0
          lQuality=75
        Case 1
          lQuality=100
        Case 2
          lQuality=150
        Case 3
          lQuality=300
        Case 4
          lQuality=600
        Case 5
          lQuality=1200
        Default
          lQuality=75
      EndSelect
      DisableGadget(#Button_ScanNext, 1)
      DisableGadget(#Button_Finish, 1)
      If hkTWAIN_AquireToPDF(GetGadgetState(#Combo_ImageType) + 1, lQuality, 0)
        ;we have at least one page to save so enable the finish button
        DisableGadget(#Button_Finish, 0)
      EndIf
      DisableGadget(#Button_ScanNext, 0)
    
    ElseIf lGadgetID = #Button_Finish
      ;finalize and save pdf file
      sPdfFileName=GetGadgetText(#Text_FileLocation)
      If sPdfFileName=""
        sPdfFileName.s=SaveFileRequester("Save PDF file",GetHomeDirectory()+"My Documents\","PDF (*.pdf)|*.pdf",0)
        If LCase(GetExtensionPart(sPdfFileName))<> "pdf"
          sPdfFileName+".pdf"
        EndIf
      SetGadgetText(#Text_FileLocation, sPdfFileName)
      EndIf
      sPdfFileName=SaveFileRequester("Save PDF file",sPdfFileName,"PDF (*.pdf)|*.pdf",0)
      If sPdfFileName
        pdf_Save(sPdfFileName)
      EndIf
      If Not hkTWAIN_AquireToPDF(GetGadgetState(#Combo_ImageType) + 1, lQuality, 1)
        MessageRequester("Scan2PDF","Could not reset PDF Engine, please restart application.")
      EndIf
      SetGadgetText(#Button_ScanNext,"Scan Next Page")
      DisableGadget(#Button_Finish, 1)
    
    ElseIf lGadgetID = #Button_Cancel
      lEvent = #PB_Event_CloseWindow
    
    ElseIf lGadgetID = #Button_Select_Source
      TWAIN_SelectImageSource(WindowID(#Window_Scan2PDF))
    
    EndIf
    
  EndIf  
Until lEvent = #PB_Event_CloseWindow ; End of the event loop

;save preferences on exit
If CreatePreferences(sCfgFileName)
  WritePreferenceInteger("Color Index", GetGadgetState(#Combo_ImageType))
  WritePreferenceInteger("Quality Index", GetGadgetState(#Combo_ImageQuality))
  WritePreferenceString("Destination File", GetGadgetText(#Text_FileLocation))
  ClosePreferences()
  Else
  MessageRequester("Scan2PDF", "Could not save program preferences file " + sCfgFileName)
EndIf

End
; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 9
; Folding = -
; EnableXP
; UseIcon = scanner.ico
; Executable = Scan2PDF.exe
; CompileSourceDirectory
; EnableCompileCount = 108
; EnableBuildCount = 22
; EnableExeConstant
; IncludeVersionInfo
; VersionField0 = 0,1,%COMPILECOUNT, %BUILDCOUNT
; VersionField1 = 0,1,%COMPILECOUNT, %BUILDCOUNT
; VersionField2 = L&H Custom Computer
; VersionField3 = Scan2PDF
; VersionField4 = Beta1
; VersionField5 = Beta1
; VersionField6 = Scan TWain to PDF File
; VersionField7 = Scan2PDF
; VersionField8 = Scan2PDF